// Copyright (C) 2001 Jean-Marc Valin

#ifndef GUINODEPARAMETERS_H
#define GUINODEPARAMETERS_H

#include <string>
#include <vector>
#include <gnome.h>
//#include <tree.h>
#include "UINodeParameters.h"
#include "GUINode.h"

namespace FD {

class UINode;

class ParameterData {
public:

	GtkWidget *optionmenu; 		/// TYPE(optionmenu)
	GtkWidget *optionmenu_menu; /// TYPE(menu)
	GtkWidget *combo_entry; 	/// VALUE(gnome_entry)
	GtkWidget *entry; 			/// VALUE(entry)
	GtkWidget *label; 			/// パラメーター名
	GtkWidget *optionmenu_val; 	/// VALUE(optionmenu)
	GtkWidget *optionmenu_menu_val; /// VALUE(menu)
	bool widget_visible; 			/// パラメーターの不可視フラグ(false=可視)
	ParameterData() : widget_visible(true) {}
};

/*
 (DL)
 Now deriving from UINodeParameters, July 16 2003
 */

class GUINodeParameters : public UINodeParameters {

protected:
	GtkWidget *nodeproperty;
	std::vector<ParameterData> params;
	GtkWidget *text_comments;
	GtkWidget *list1;
	GtkWidget *list2;
	GtkWidget *input_entry, *output_entry;
	GtkWidget *inputSelect, *outputSelect;
	GtkWidget *param_popup_window; // パラメータポップwindow
	void createWindow();

public:
	GUINodeParameters(UINode *_node, std::string type);
	virtual ~GUINodeParameters();
	void show();
	void hide();
	void apply();
	void changed();
	ParameterData *getParamDataNamed(std::string n);
	//virtual void insertLoadedParam(ParameterText *param, std::string type, std::string value);
	GUINode *getGUINode() {
		return dynamic_cast<GUINode*>(node);
	}
	void addInput();
	void addOutput();
	void removeInput();
	void removeOutput();
	void setInputSelect(GtkWidget *w) {
		inputSelect=w;
	}
	void setOutputSelect(GtkWidget *w) {
		outputSelect=w;
	}
	void unsetInputSelect(GtkWidget *w) {
		if (inputSelect==w)
			inputSelect=NULL;
	}
	void unsetOutputSelect(GtkWidget *w) {
		if (outputSelect==w)
			outputSelect=NULL;
	}

	/// パラメーターの排他処理用関数
	void hideParameters();
	void hideFlagWidgetShowHide();
	void setHideFlagRecurse(std::string target_param, std::string target_value,
			std::set <std::string>*loop, bool all_searching, bool parent_hide);
	void setHideFlagAllRecurse();
	// パラメータポップアップウィンドウ
	void showParamPopup(GtkWidget *dvent_box);
	void deleteParamPopup();
};

}//namespace FD

#endif
